/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { InputBase } from "./InputBase";
import { enumGetBox, EnumUtil, markType } from "igniteui-react-core";
import { WCNativeHelper } from "./WCNativeHelper";
import { InputType_$type } from "./InputType";
import { InputInputmode_$type } from "./InputInputmode";
import { ComponentValueChangedEventArgs } from "./ComponentValueChangedEventArgs";
/**
 * @hidden
 */
export let Input = /*@__PURE__*/ (() => {
    class Input extends InputBase {
        constructor() {
            super(...arguments);
            this.change = null;
        }
        changeChanged() {
            if (this.change != null) {
                this.g.r("change", (a) => this.change(this, ComponentValueChangedEventArgs.a(a)));
            }
            else {
                this.g.u("change");
            }
        }
        get au() {
            let ret_ = this.g.n("value");
            return ret_;
        }
        set au(a) {
            let value_ = a;
            this.g.v("value", value_);
        }
        get ai() {
            let ret_ = this.g.n("type");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(InputType_$type, EnumUtil.getEnumValue(InputType_$type, this.g.f(InputType_$type, ret_)));
            return EnumUtil.getEnumValue(InputType_$type, ret_);
        }
        set ai(a) {
            let value_ = enumGetBox(InputType_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.g.v("type", value_);
        }
        get ah() {
            let ret_ = this.g.n("inputmode");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(InputInputmode_$type, EnumUtil.getEnumValue(InputInputmode_$type, this.g.f(InputInputmode_$type, ret_)));
            return EnumUtil.getEnumValue(InputInputmode_$type, ret_);
        }
        set ah(a) {
            let value_ = enumGetBox(InputInputmode_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.g.v("inputmode", value_);
        }
        get at() {
            let ret_ = this.g.n("pattern");
            return ret_;
        }
        set at(a) {
            let value_ = a;
            this.g.v("pattern", value_);
        }
        get ao() {
            let ret_ = this.g.n("minLength");
            return ret_;
        }
        set ao(a) {
            let value_ = a;
            this.g.v("minLength", value_);
        }
        get an() {
            let ret_ = this.g.n("minlength");
            return ret_;
        }
        set an(a) {
            let value_ = a;
            this.g.v("minlength", value_);
        }
        get am() {
            let ret_ = this.g.n("maxLength");
            return ret_;
        }
        set am(a) {
            let value_ = a;
            this.g.v("maxLength", value_);
        }
        get al() {
            let ret_ = this.g.n("maxlength");
            return ret_;
        }
        set al(a) {
            let value_ = a;
            this.g.v("maxlength", value_);
        }
        get as() {
            let ret_ = this.g.n("min");
            return ret_;
        }
        set as(a) {
            let value_ = a;
            this.g.v("min", value_);
        }
        get ar() {
            let ret_ = this.g.n("max");
            return ret_;
        }
        set ar(a) {
            let value_ = a;
            this.g.v("max", value_);
        }
        get ap() {
            let ret_ = this.g.n("step");
            return ret_;
        }
        set ap(a) {
            let value_ = a;
            this.g.v("step", value_);
        }
        get aj() {
            let ret_ = this.g.n("autofocus");
            return ret_;
        }
        set aj(a) {
            let value_ = a;
            this.g.v("autofocus", value_);
        }
        get aq() {
            let ret_ = this.g.n("autocomplete");
            return ret_;
        }
        set aq(a) {
            let value_ = a;
            this.g.v("autocomplete", value_);
        }
        get ak() {
            let ret_ = this.g.n("validateOnly");
            return ret_;
        }
        set ak(a) {
            let value_ = a;
            this.g.v("validateOnly", value_);
        }
        aw() {
            this.nativeElement.select();
        }
        ay(a = -1) {
            this.nativeElement.stepUp(this.g.i(a));
        }
        ax(a = -1) {
            this.nativeElement.stepDown(this.g.i(a));
        }
    }
    Input.$t = /*@__PURE__*/ markType(Input, 'Input', InputBase.$);
    Input.__marshalByValueIgnore1 = ["minlength", "maxlength"];
    return Input;
})();
