/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { MaskInputBase } from "./MaskInputBase";
import { enumGetBox, markType } from "igniteui-react-core";
import { DatePartDeltas } from "./DatePartDeltas";
import { ComponentDateValueChangedEventArgs } from "./ComponentDateValueChangedEventArgs";
import { DatePart_$type } from "./DatePart";
/**
 * @hidden
 */
var DateTimeInput = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(DateTimeInput, _super);
    function DateTimeInput() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.change = null;
        return _this;
    }
    Object.defineProperty(DateTimeInput.prototype, "ar", {
        get: function () {
            var ret_ = this.g.n("inputFormat");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.g.v("inputFormat", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DateTimeInput.prototype, "ap", {
        get: function () {
            var ret_ = this.g.n("value");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.g.v("value", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DateTimeInput.prototype, "an", {
        get: function () {
            var ret_ = this.g.n("min");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.g.v("min", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DateTimeInput.prototype, "al", {
        get: function () {
            var ret_ = this.g.n("max");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.g.v("max", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DateTimeInput.prototype, "ao", {
        get: function () {
            var ret_ = this.g.n("minValue");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.g.v("minValue", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DateTimeInput.prototype, "am", {
        get: function () {
            var ret_ = this.g.n("maxValue");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.g.v("maxValue", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DateTimeInput.prototype, "aq", {
        get: function () {
            var ret_ = this.g.n("displayFormat");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.g.v("displayFormat", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DateTimeInput.prototype, "aj", {
        get: function () {
            var ret_ = this.g.m("spinDelta", function (a) { return new DatePartDeltas(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.g.v("spinDelta", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DateTimeInput.prototype, "ak", {
        get: function () {
            var ret_ = this.g.n("spinLoop");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.g.v("spinLoop", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DateTimeInput.prototype, "as", {
        get: function () {
            var ret_ = this.g.n("locale");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.g.v("locale", value_);
        },
        enumerable: false,
        configurable: true
    });
    DateTimeInput.prototype.changeChanged = function () {
        var _this = this;
        if (this.change != null) {
            this.g.r("change", function (a) { return _this.change(_this, ComponentDateValueChangedEventArgs.a(a)); });
        }
        else {
            this.g.u("change");
        }
    };
    DateTimeInput.prototype.av = function () {
        this.nativeElement.connectedCallback();
    };
    DateTimeInput.prototype.ax = function (a, b) {
        if (b === void 0) {
            b = -1;
        }
        this.nativeElement.stepUp(this.g.i(enumGetBox(DatePart_$type, a)), this.g.i(b));
    };
    DateTimeInput.prototype.aw = function (a, b) {
        if (b === void 0) {
            b = -1;
        }
        this.nativeElement.stepDown(this.g.i(enumGetBox(DatePart_$type, a)), this.g.i(b));
    };
    DateTimeInput.prototype.au = function () {
        this.nativeElement.clear();
    };
    DateTimeInput.$t = markType(DateTimeInput, 'DateTimeInput', MaskInputBase.$);
    return DateTimeInput;
}(MaskInputBase));
export { DateTimeInput };
