/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { MaskInputBase } from "./MaskInputBase";
import { enumGetBox, markType } from "igniteui-react-core";
import { DatePartDeltas } from "./DatePartDeltas";
import { ComponentDateValueChangedEventArgs } from "./ComponentDateValueChangedEventArgs";
import { DatePart_$type } from "./DatePart";
/**
 * @hidden
 */
export let DateTimeInput = /*@__PURE__*/ (() => {
    class DateTimeInput extends MaskInputBase {
        constructor() {
            super(...arguments);
            this.change = null;
        }
        get ar() {
            let ret_ = this.g.n("inputFormat");
            return ret_;
        }
        set ar(a) {
            let value_ = a;
            this.g.v("inputFormat", value_);
        }
        get ap() {
            let ret_ = this.g.n("value");
            return ret_;
        }
        set ap(a) {
            let value_ = a;
            this.g.v("value", value_);
        }
        get an() {
            let ret_ = this.g.n("min");
            return ret_;
        }
        set an(a) {
            let value_ = a;
            this.g.v("min", value_);
        }
        get al() {
            let ret_ = this.g.n("max");
            return ret_;
        }
        set al(a) {
            let value_ = a;
            this.g.v("max", value_);
        }
        get ao() {
            let ret_ = this.g.n("minValue");
            return ret_;
        }
        set ao(a) {
            let value_ = a;
            this.g.v("minValue", value_);
        }
        get am() {
            let ret_ = this.g.n("maxValue");
            return ret_;
        }
        set am(a) {
            let value_ = a;
            this.g.v("maxValue", value_);
        }
        get aq() {
            let ret_ = this.g.n("displayFormat");
            return ret_;
        }
        set aq(a) {
            let value_ = a;
            this.g.v("displayFormat", value_);
        }
        get aj() {
            let ret_ = this.g.m("spinDelta", (a) => new DatePartDeltas());
            return ret_;
        }
        set aj(a) {
            let value_ = a;
            this.g.v("spinDelta", value_);
        }
        get ak() {
            let ret_ = this.g.n("spinLoop");
            return ret_;
        }
        set ak(a) {
            let value_ = a;
            this.g.v("spinLoop", value_);
        }
        get as() {
            let ret_ = this.g.n("locale");
            return ret_;
        }
        set as(a) {
            let value_ = a;
            this.g.v("locale", value_);
        }
        changeChanged() {
            if (this.change != null) {
                this.g.r("change", (a) => this.change(this, ComponentDateValueChangedEventArgs.a(a)));
            }
            else {
                this.g.u("change");
            }
        }
        av() {
            this.nativeElement.connectedCallback();
        }
        ax(a, b = -1) {
            this.nativeElement.stepUp(this.g.i(enumGetBox(DatePart_$type, a)), this.g.i(b));
        }
        aw(a, b = -1) {
            this.nativeElement.stepDown(this.g.i(enumGetBox(DatePart_$type, a)), this.g.i(b));
        }
        au() {
            this.nativeElement.clear();
        }
    }
    DateTimeInput.$t = /*@__PURE__*/ markType(DateTimeInput, 'DateTimeInput', MaskInputBase.$);
    return DateTimeInput;
})();
