import { IgrInputBase } from "./igr-input-base";
export class IgrMaskInputBase extends IgrInputBase {
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor(props) {
        super(props);
    }
    /**
     * The prompt symbol to use for unfilled parts of the mask.
    */
    get prompt() {
        return this.i.af;
    }
    set prompt(v) {
        this.i.af = v;
    }
    connectedCallback() {
        this.i.ag();
    }
    /**
     * Selects all text within the input.
    
    */
    select() {
        this.i.ah();
    }
}
