import * as React from 'react';
import { IgrBaseAlertLike, IIgrBaseAlertLikeProps } from "./igr-base-alert-like";
import { Toast } from "./Toast";
/**
 * A toast component is used to show a notification
*/
export declare class IgrToast extends IgrBaseAlertLike<IIgrToastProps> {
    protected createImplementation(): Toast;
    /**
                                 * @hidden
                                 */
    get i(): Toast;
    constructor(props: IIgrToastProps);
    componentDidMount(): void;
    render(): React.DOMElement<any, Element>;
    protected _elRef: HTMLElement;
    protected _getMainRef(ref: any): void;
}
export interface IIgrToastProps extends IIgrBaseAlertLikeProps {
}
